#-*- coding:utf-8 -*-
import requests
import json
from entity.OrderInfo import Currency

import logging
import random
import string

class CallbackOrderUtils():
    
    callbackurl = "http://123.103.51.83/mgr/"
    #callbackurl = "http://192.168.1.5:11009/"
    
    def __init__(self):
        self.salt = ''.join(random.sample(string.ascii_letters + string.digits, 16))+'|'
    #回调占座结果
    def BallbackOrder(self,orderNo,orderStatus,orderPnr,accountType,userName):
        url = self.callbackurl+"orOrdertb/orderCallBack"
        self.salt = orderNo+'|'
        fromParam = {}
        fromParam['orderNo'] = orderNo
        fromParam['orderStatus'] = orderStatus
        fromParam['orderPnr'] = orderPnr
        fromParam['accountType'] = accountType
        fromParam['userName'] = userName
        session = requests.session()
        logging.info(self.salt+'回调占座结果:'+url)
        logging.info(self.salt+str(fromParam))
        res = session.post(url,data=fromParam)
        logging.info(self.salt+res.text)
    #回调价格
    def BallbackPrice(self,orderNo,webPriceGo,webPriceBack,agentPriceGo,agentPriceBack,bigPriceGo,bigPriceBack):
        url = self.callbackurl+"orOrdertb/ballbackPrice"
        self.salt = orderNo+'|'
        fromParam = {}
        fromParam['orderNo'] =   '2018030915450779734174620'  #orderNo
        fromParam['webPrice'] = str({'go':webPriceGo,'back':webPriceBack})
        fromParam['agentPrice'] = str({'go':agentPriceGo,'back':agentPriceBack})
        fromParam['bigPrice'] = str({'go':bigPriceGo,'back':bigPriceBack})
        logging.info(self.salt+'价格回调：'+url)
        logging.info(self.salt+str(fromParam))
        session = requests.session()
        res = session.post(url,data=fromParam)
        logging.info(self.salt+res.text)
    #通过机场三字码查询币种与汇率
    def cityToCurrency(self,stationCode):
        url = self.callbackurl+"scCitycurrency/cityToCurrency"
        fromParam = {}
        fromParam['stationCode'] = stationCode
        session = requests.session()
        logging.info(self.salt+url)
        logging.info(self.salt+str(fromParam))
        res = session.post(url,data=fromParam)
        logging.info(self.salt+res.text)
        json_str = json.loads(res.text)
        if 200 == json_str['status']:
            json_str = json_str['attachment']
            currency = Currency()
            currency.stationCode = json_str['stationCode']                  #机场三字码
            currency.currencyCode = json_str['currencyCode']                #币种
            currency.exchangeCode = json_str['exchangeCode']                #转化币种 一般为CNY
            currency.countryCode = json_str['countryCode']                  #城市编码
            currency.UnionPayOriginRate = json_str['UnionPayOriginRate']    #银联原始汇率
            currency.UnionPayFinalRate = json_str['UnionPayFinalRate']      #银联调整后汇率
            currency.AkOriginRate = json_str['AkOriginRate']                #亚航原始汇率
            currency.AkFinalRate = json_str['AkFinalRate']                  #亚航调整后汇率
            return currency
        return
    #获取代理IP
    def getProxyIP(self):
        session = requests.session()
        res = session.get('http://ip.16yun.cn:817/myip/pl/89932955-62b8-40bf-990b-fb1671267c51/?s=fpbefmgsks&u=laopeng')
        ip = res.text.split('\n')[0]
        print(ip)
        return ip.strip()
if __name__ == '__main__':
    cout = CallbackOrderUtils()
    #cout.BallbackOrder('2018030915450779734174620', '1', 'YUNIHJ', '代理人占座', 'CNTRIPTOPK_ADMIN')
    #currency = cout.cityToCurrency('CAN')
    #print(currency.currencyCode)
    ip = cout.getProxyIP()
    print('----'+ip+'-----')
    